#include	<mriext.h>
#include	<string.h>
#include	"tmp_def.h"
#include	"duscc.h"


extern void	rs_rcv(),rs_snd();
extern int	inportb(),outportb(),outportl(),yes(),ret();
extern void	skipspace(),wait();

extern char	stpflg,crflg;
extern char	err_msg[],buffer[],led_data[];
extern int	sw_ctr;

void	mmi_init(),led_set();
int	led_chk(),sw_chk();

int	green = 0;
int	red = 0;


void	mmi()
{
	rs_snd("\n **** MMI Board Test **** \n");

	rs_snd("\n  MMI board is ready ? \n");
	if ( yes() != 0 ) return;

	mmi_init();

	led_set(0,0);
	led_set(1,0);
	led_set(2,0);
	led_set(3,0);

	/*	[1] Counter Test	*/
	strcpy(err_msg,"\n ---- Check MMI:Counter ---- \n");
	rs_snd("\n [1] Counter Test \n"); 
	outportb(TCR0,0x00);		/*	clear TCR0	*/
	outportl(CPR0,0x01e848);	/*	TOUT = 1Hz	*/
			/*	0x1e848 =   1/2    sec /(1/8MHz) / 32 prescaler	*/
	outportb(TCR0,0x41);		/*	square wave	*/
	rs_snd("\n  Counter CLK is changed to 1 Hz.");
	rs_snd("\n  Watch whether 7seg.LEDs are on in turn.");
	if ( yes() != 0 ) return;
	outportb(TCR0,0x00);		/*	clear TCR0	*/
	outportl(CPR0,0x00003f);	/*	TOUT = 2kHz	*/
			/*	0x3f  = (1/2000)/2 sec /(1/8MHz) / 32 prescaler	*/
	outportb(TCR0,0x41);		/*	square wave	*/
	rs_snd("\n  Counter CLK is returned to 2 kHz. \n");

	/*	[2] 7seg.LED Test 	*/
	rs_snd("\n [2] 7seg.LED Test \n");
	if ( led_chk(0) != 0 ) return;	/*	7seg.LED(0)	*/
	if ( led_chk(1) != 0 ) return;	/*	7seg.LED(1)	*/
	if ( led_chk(2) != 0 ) return;	/*	7seg.LED(2)	*/
	if ( led_chk(3) != 0 ) return;	/*	7seg.LED(3)	*/

	/*	[3] Green/Red LED Test	*/
	strcpy(err_msg,"\n ---- Check MMI:Green/Red LED ---- \n");
	rs_snd("\n [3] Green/Red LED Test \n");
	outportb(PADR0,0);				/*	Green->OFF,RED->OFF	*/
	rs_snd("\n  Green LED is off, Red LED is off. ");
	if ( yes() != 0 ) return;
	outportb(PADR0,RED);				/*	Green->OFF,RED->ON	*/
	rs_snd("\n  Green LED is off, Red LED is on. ");
	if ( yes() != 0 ) return;
	outportb(PADR0,GREEN);				/*	Green->ON ,RED->OFF	*/
	rs_snd("\n  Green LED is on, Red LED is off. ");
	if ( yes() != 0 ) return;
	outportb(PADR0,RED+GREEN);			/*	Green->ON ,RED->ON	*/
	rs_snd("\n  Green LED is on, Red LED is on. ");
	if ( yes() != 0 ) return;
	outportb(PADR0,0);				/*	Green->OFF,RED->OFF	*/
	rs_snd("\n  Green LED is off, Red LED is off. ");
	if ( yes() != 0 ) return;

	/*	[4] Switch Read Test	*/
	strcpy(err_msg,"\n ---- Check MMI:Switch ---- \n");
	rs_snd("\n [4] Switch Read Test \n");
	if ( sw_chk(0x00) != 0 ) return;
	if ( sw_chk(0x01) != 0 ) return;
	if ( sw_chk(0x02) != 0 ) return;
	if ( sw_chk(0x04) != 0 ) return;
	if ( sw_chk(0x08) != 0 ) return;
	if ( sw_chk(0x05) != 0 ) return;
	if ( sw_chk(0x0a) != 0 ) return;

	/*	[5] Push Button Test	*/
	strcpy(err_msg,"\n ---- Check MMI:Push Button ---- \n");
	rs_snd("\n [5] Push Button Test \n");
	sw_ctr = 0;
	rs_snd("\n  Push the push button for interrupt.(If there is no responce, hit F1 key for break.)\n");


	outportb(TCR0,0x00);	/*	timer stop	*/

	outportb(PBCR0,0x84);	/*	interrupt enable	*/
	while ( sw_ctr == 0 && stpflg != ACTIVE );
	outportb(PBCR0,0x80);	/*	interrupt disable	*/

	if ( stpflg == ACTIVE )
	{
		rs_snd(err_msg);
		return;
	}
	rs_snd("  O.K. \n");

	rs_snd("\n **** MMI Board Test is Complete **** \n");
}


void	mmi_init()
{
	/*	PI/T 0	*/
	outportb(PGCR0,0x00);	/*	clear PGCR0	*/
	outportb(PSRR0,0x1e);
	outportb(PACR0,0xa0);	/*	submode 1x	*/
	outportb(PADDR0,0xff);	/*	all output	*/
	outportb(PBCR0,0x80);	/*	submode 1x	*/
	outportb(PBDDR0,0x10);
	outportb(PGCR0,0x22);	/*	mode 0		*/
	outportb(TCR0,0x00);	/*	clear TCR0	*/
	outportl(CPR0,0x00003f);	/*	TOUT 2kHz	*/
			/*	0x3f = (1/2000)/2 sec /(1/8MHz) /32 prescaler	*/
	outportb(TCR0,0x41);	/*	square wave	*/

	/*	set vector for switch interrupt	*/
	asm(
"	MOVEA.L		#$06c,A0	* LEVEL 3  PI/T interrupt ",
"	MOVE.L		#_swint,(A0)"
	);
}


void	led_set( led_no, data )
int	led_no,data;
{
	outportb(PADR0,green*0x80+red*0x40+led_no*0x10+data);
	outportb(PACR0,0xa0);
	outportb(PACR0,0xa8);
	outportb(PACR0,0xa0);

	led_data[led_no] = data;
}


int	led_chk( led_no )
int	led_no;
{
	int	c;		/*	number to be displayed	*/

	itoa(led_no,buffer);
	rs_snd("\n  7seg.LED(");
	rs_snd(buffer);
	rs_snd(") is selected. ");
	rs_snd("\n  It varies from '0' to '9' cyclically. ");
	rs_snd("\n  If it is O.K. , hit key 'Y'. >> ");
	c = 0;
	while ( (crflg != ACTIVE) && (stpflg != ACTIVE) )
	{
		led_set(led_no,c);
		c++;
		if ( c > 9 ) c = 0;
		wait(LED_WAIT);		/*	turn ON   1,2sec	*/
	}
	crflg = !ACTIVE;
	if ( stpflg == ACTIVE ) return(1);
	rs_rcv(buffer);
	skipspace();
	if ( strcmp(buffer,"y") != 0 && strcmp(buffer,"Y") != 0 )
	{
		rs_snd("\n ---- Check MMI:7seg.LED(");
		rs_snd(buffer);
		rs_snd(") ---- \n");
		return(1);
	}
	rs_snd("  O.K. \n");
	return(0);
}


int	sw_chk( data )
int	data;
{
	int	sw_data;

	itostr((unsigned int)data,buffer,16);
	rs_snd("\n  Set switch ");
	rs_snd(buffer);
	rs_snd("(hex)");
	if ( ret() != 0 ) return(1);
	sw_data = inportb(PBDR0) & 0x0f;
	itostr((unsigned int)sw_data,buffer,16);
	rs_snd("\n  Switch data = ");
	rs_snd(buffer);
	rs_snd("(hex)\n");
	if ( (sw_data & 0x0f) != data ) {	/* switch has 4 bits	*/
		rs_snd(err_msg);
		return(1);
	}
	rs_snd("  O.K. \n");
	return(0);
}


/*	switch interrupt function	*/
interrupt void	swint()
{
	outportb(PSR0,0x08);	/*	clear H4S  (clear interrupt)	*/
	sw_ctr++;		/*	interrupt counter	*/
}
