#include	<mriext.h>
#include	<string.h>
#include	"tmp_def.h"
#include	"duscc.h"

extern void	rs_snd();
extern int	inportb(),outportb(),yes(),ret();

extern char	crflg,stpflg,nextflg;
extern char	err_msg[],buffer[];
extern int	ts_ctr;			/*	interrupt counter	*/

void	re_ts_init(),re(),ts();
int	re_ct_chk(),re_rst_chk();


void	re_ts()
{
	int	sel;	/*	target select value	*/

	rs_snd("\n **** Rotary Encoder/ Touch Sensor Board Test **** \n");

	rs_snd("\n  RE/TS board is ready ? \n");
	if ( yes() != 0 ) return;

	re_ts_init();	/*	initialize	*/

	/*	select target function	*/
	sel = NON;
	while ( sel == NON && stpflg != ACTIVE )
	{
		rs_snd("\n  Select target.");
		rs_snd("\n  (1) Rotary Encoder (2) Touch Sensor >> ");
		sel = inp();
		if ( sel < 1 || 2 < sel ) sel = NON;
	}
	switch( sel )
	{
		case 1:
			re();
			break;
		case 2:
			ts();
			break;
		default:
			stpflg = ACTIVE;
			break;
	}

	if ( stpflg != ACTIVE )
	rs_snd("\n ****  Rotary Encoder/ Touch Sensor Board Test is Complete **** \n");
}


void	re_ts_init()
{
	/*	RE/TS	*/
	outportb(TSIE,0x00);
	outportb(CRST,0x03);	/*	counter reset	*/

	/*	set vector for interrupt	*/
	asm(
"	MOVEA.L		#$130,A0	*	130(h) = 76(d) * 4",
"	MOVE.L		#_tsint,(A0)"
	);
}



void	re()
{
	/*	[1] Rotary Encoder Count Test	*/
	strcpy(err_msg,"\n ---- Check RE/TS:RE Count Function ---- \n");
	rs_snd("\n [1] Rotary Encoder Count Test \n");
	if ( re_ct_chk() != 0 ) return;

	/*	[2] Rotary Encoder Counter Reset Test	*/
	strcpy(err_msg,"\n ---- Check RE/TS:RE Counter Rest Function ---- \n");
	rs_snd("\n [2] Rotary Encoder Counter Reset Test \n");
	if ( re_rst_chk() != 0 ) return;
}


/*	rotary encoder counter test	*/
int	re_ct_chk()
{
	int	old_data_r,old_data_l,new_data_r,new_data_l;
	int	data_rh,data_rl,data_lh,data_ll;
	int	col;
	char	rebuf[20];


	while ( nextflg != ACTIVE && stpflg != ACTIVE )
	{
		rs_snd("\n  Hit return key to start counting. ( Hit F2 key for next. ) : ");
		while ( crflg != ACTIVE && nextflg != ACTIVE && stpflg != ACTIVE );
		crflg = !ACTIVE;

		data_rl = inportb(EDRL) & 0xff;
		data_rh = inportb(EDRH) & 0x0f;
		data_ll = inportb(EDLL) & 0xff;
		data_lh = inportb(EDLH) & 0x0f;

		/*	display rotary encoder data(H)  in 4 coloum	*/
		strcpy(buffer,"0000");
		col = itostr((unsigned int)data_rh,rebuf,2);
		itostr((unsigned int)data_rh,buffer+(4-col),2);
		rs_snd("\n Right(High) : ");
		rs_snd(buffer);

		/*	display rotary encoder data(L)  in 8 coloum	*/
		strcpy(buffer,"00000000");
		col = itostr((unsigned int)data_rl,rebuf,2);
		itostr((unsigned int)data_rl,buffer+(8-col),2);
		rs_snd("\n Right(Low)  : ");
		rs_snd(buffer);

		/*	display rotary encoder data(H)  in 4 coloum	*/
		strcpy(buffer,"0000");
		col = itostr((unsigned int)data_lh,rebuf,2);
		itostr((unsigned int)data_lh,buffer+(4-col),2);
		rs_snd("\n Left(High)  : ");
		rs_snd(buffer);

		/*	display rotary encoder data(L)  in 8 coloum	*/
		strcpy(buffer,"00000000");
		col = itostr((unsigned int)data_ll,rebuf,2);
		itostr((unsigned int)data_ll,buffer+(8-col),2);
		rs_snd("\n Left(Low)   : ");
		rs_snd(buffer);

		old_data_r = ( data_rh << 8 ) + data_rl;
		if ((old_data_r & 0x800) != 0)			/*	if data is minus	*/
			old_data_r = (old_data_r | 0xfffff000);
		old_data_l = ( data_lh << 8 ) + data_ll;
		if ((old_data_l & 0x800) != 0)			/*	if data is minus	*/
			old_data_l = (old_data_l | 0xfffff000);

		/*	display old data  in decimal	*/
		rs_snd("\n    Right Count (Old) : ");
		itoa(old_data_r,buffer);
		rs_snd(buffer);
		rs_snd("\n    Left Count (Old)  : ");
		itoa(old_data_l,buffer);
		rs_snd(buffer);

		rs_snd("\n\n  Hit return key to stop counting. ( Hit F2 key for next. ) : ");
		while ( crflg != ACTIVE && nextflg != ACTIVE && stpflg != ACTIVE );
		crflg = !ACTIVE;

		data_rl = inportb(EDRL) & 0xff;
		data_rh = inportb(EDRH) & 0x0f;
		data_ll = inportb(EDLL) & 0xff;
		data_lh = inportb(EDLH) & 0x0f;

		new_data_r = ( data_rh << 8 ) + data_rl;
		if ((new_data_r & 0x800) != 0)			/*	if data is minus	*/
			new_data_r = (new_data_r | 0xfffff000);
		new_data_l = ( data_lh << 8 ) + data_ll;
		if ((new_data_l & 0x800) != 0)			/*	if data is minus	*/
			new_data_l = (new_data_l | 0xfffff000);

		/*	display new data  in decimal	*/
		rs_snd("\n    Right Count (New) : ");
		itoa(new_data_r,buffer);
		rs_snd(buffer);
		rs_snd("\n    Left Count (New)  : ");
		itoa(new_data_l,buffer);
		rs_snd(buffer);

		/*	display count difference	*/
		rs_snd("\n\n  [ Count Difference ]");
		rs_snd("\n    Right : ");
		itoa(new_data_r-old_data_r,buffer);
		rs_snd(buffer);
		rs_snd("\n    Left  : ");
		itoa(new_data_l-old_data_l,buffer);
		rs_snd(buffer);
	}
	nextflg = crflg = !ACTIVE;	/*	clear next-flag & CR-flag	*/
	if ( stpflg == ACTIVE )
	{
			rs_snd(err_msg);
			return(1);
	}
	rs_snd("  O.K. \n");
	return(0);
}


int	re_rst_chk()
{
	int	mode,data_r,data_l;

	while ( nextflg != ACTIVE && stpflg != ACTIVE )
	{

		/*	mode select	*/
		mode = NON;
		while ( mode == NON && nextflg != ACTIVE && stpflg != ACTIVE)
		{
			rs_snd("\n  Select reset mode. ( Hit F2 key to return. ) ");
			rs_snd("\n  (1)Right (2)Left (3)Both  >> ");
			mode = inp();
			if ( mode < 1 || 3 < mode ) mode = NON;
		}

		/*	reset counter	*/
		outportb(CRST,mode);

		/*	get data	*/
		data_r = ( (inportb(EDRH) & 0x0f)<<8 ) + inportb(EDRL);
		data_l = ( (inportb(EDLH) & 0x0f)<<8 ) + inportb(EDLL);

		/*	display data	*/
		rs_snd("\n    Right Count : ");
		itoa(data_r,buffer);
		rs_snd(buffer);
		rs_snd("\n    Left Count  : ");
		itoa(data_l,buffer);
		rs_snd(buffer);
	}
	nextflg = crflg = !ACTIVE;	/*	clear next-flag & CR-flag	*/
	if ( stpflg == ACTIVE )
	{
		rs_snd(err_msg);
		return(1);
	}

	rs_snd("\n  O.K.");
	return(0);
}


void	ts()
{
	int	data;

	/*	[3] Touch Sensor Sense Test	*/
	strcpy(err_msg,"\n ---- Check RE/TS:Touch Sensor ---- \n");
	rs_snd("\n [3] Touch Sensor Sense Test \n");
	while ( nextflg != ACTIVE && stpflg != ACTIVE )
	{
		rs_snd("\n  Hit return key to scan touch senseor states. ( Hit F2 key for next. ) : ");
		while ( crflg != ACTIVE && nextflg != ACTIVE && stpflg != ACTIVE );
		crflg = !ACTIVE;
		data = inportb(EDRH);				/*	get touch sensor data	*/
		if ( (data & 0x80) != 0x00 ) rs_snd("\n  [SF] : ON ");
		else rs_snd("\n  [SF] : OFF ");
		if ( (data & 0x40) != 0x00 ) rs_snd("\n  [L]  : ON ");
		else rs_snd("\n  [L]  : OFF ");
		if ( (data & 0x20) != 0x00 ) rs_snd("\n  [R]  : ON ");
		else rs_snd("\n  [R]  : OFF ");
		if ( (data & 0x10) != 0x00 ) rs_snd("\n  [M]  : ON ");
		else rs_snd("\n  [M]  : OFF ");
	}
	nextflg = !ACTIVE;
	if ( stpflg == ACTIVE )
	{
			rs_snd(err_msg);
			return;
	}
	rs_snd("\n  O.K. \n");

	/*	[4] Touch Sensor Interrupt Test	*/
	strcpy(err_msg,"\n ---- Check RE/TS:TS Interrupt Function ---- \n");
	rs_snd("\n [4] Touch Sensor Interrupt Test \n");
	ts_ctr = 0;
	rs_snd("\n  Touch one of touch sensors for interrupt.(If there is no response, hit F1 key for break.)\n");

	outportb(TSIE,0x01);	/*	interrupt enable	*/
	outportb(VIMR,0x10);	/*	VME IRQ4  enable	*/

	while ( ts_ctr == 0 && stpflg != ACTIVE );

	outportb(VIMR,0x00);	/*	VME IRQ   disable	*/
	outportb(TSIE,0x00);	/*	interrupt disable	*/
	if ( stpflg == ACTIVE )
	{
		rs_snd(err_msg);
		return;
	}

	rs_snd("  O.K. \n");
}


/*	touch sensor interrupt function	*/
interrupt void	tsint()
{
	ts_ctr++;	/*	interrupt counter	*/
}
